#include "FromSuperBrain.h"


#include "CurlHttp.h"
#include "fmt/format.h"


FromSuperBrain::FromSuperBrain()
{
    m_logger = spdlog::get("FromSuperBrain");
    if(m_logger == nullptr)
    {
        SPDLOG_ERROR("FromSuperBrain logger is nullptr");
        return;
    }

    m_url = "http://192.1.2.64:30000/vos";
    m_appKey = "x1pcq13r";
    m_appSecret = "Setyir9yxvSiFGB/wsv4YHWiNmrgeaZhzJKi7c7Gmk04Z5Kd/hCifL+0WnfCRDJF";
}

FromSuperBrain::~FromSuperBrain()
{

}

/* 获取token */
bool FromSuperBrain::getToken()
{
    std::string response;
    std::string httpBody = R"({"appSecret":"Setyir9yxvSiFGB/wsv4YHWiNmrgeaZhzJKi7c7Gmk04Z5Kd/hCifL+0WnfCRDJF","appKey":"x1pcq13r"})";
    std::vector<std::string> vecHeader;
    vecHeader.push_back("Content-Type: application/json");
    std::string url = m_url + m_tokenPath;
    SPDLOG_LOGGER_DEBUG(m_logger, "url:{}", url);
    SPDLOG_LOGGER_DEBUG(m_logger, "httpBody:{}", httpBody);
    if(!CurlHttp::Post(url, vecHeader, httpBody, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get Token failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);
    m_token = response;

    return true;
}


/* 获取算法列表 */
bool FromSuperBrain::getTaskTypeList()
{
    if(m_token.empty())
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Token is empty");
        return false;
    }
    std::string response;
    std::vector<std::string> vecHeader;
    vecHeader.push_back(fmt::format("accessToken: {}", m_token));
    std::string url = m_url + m_taskTypeListPath;
    if(!CurlHttp::Get(url, vecHeader, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get TaskTypeList failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);
    m_taskTypeList = response;

    return true;
}

/* 获取设备列表信息 */
bool FromSuperBrain::getDeviceList()
{
    if(m_token.empty())
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Token is empty");
        return false;
    }
    std::string response;
    std::vector<std::string> vecHeader;
    vecHeader.push_back(fmt::format("accessToken: {}", m_token));
    std::string url = m_url + m_deviceListPath;
    if(!CurlHttp::Get(url, vecHeader, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get TaskTypeList failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);

    return true;
}

